// Capsule9.js
// 29-10-2018
// Pour p5.js (Processing en JavaScript)
// OK Processing v 3.3.7 en mode p5.js
//
// Utilise la library p5.js
// Utilise la library p5.sound.js
// Utilise la library p5.dom.js
// Utilise la library socket.io-1.4.5.js
//
// En local: OK Firefox 62  
// En local: Problem Chrome 69  Safari 12  Opera 56 "Cross origin requests are only supported for HTTP."
// En ligne OK  MacOSX: Firefox 62  Chrome 69  Safari 12  Opera 56 
// En ligne OK Android: Firefox 62  Chrome 69  
//
// https://p5js.org/reference/#/p5.SoundFile
// https://p5js.org/reference/#/p5.Amplitude
// https://socket.io/blog/socket-io-1-4-5/
//

var AdressIP =[192, 168, 1, 14, 4000];
var AdressIPServer; // Exemple: http://192.168.1.14:4000
var NomSon1 = "cemuhi-12s.mp3";
var NomSon2 = "LeHeron.mp3";
var TitrePage = "Capsule9";

var ChampTexte = new Array(5);
var NomSon = NomSon1;
var NomSonDistant = NomSon1;
var Son;
var DureeSon = 0;
var rms = 0;
var Bord = 50; // pixels
var socket;
var NbrPlayServer = 0;
var Bouton = new Array(6);
var BoutonRec = new Array(3);
var Reception = "Rien pour l'instant";
var MenuLocal, MenuDistant;
var Progress = 0;
var Recu1 = "?";
var Recu2 = "?";
var Recu3 = "?";
var DecalX = 25;
var DecalY = 65;
var SliderVertical;
var Volume;
var Recording = false;
var Playing = false;

function preload() {
  Son = loadSound(NomSon);
  // ChargeSon();
  print('Fin preload');
}

function setup() {
  createElement('title', "Capsule côté Tablette");

  Texte1 = createElement('h2', '');
  Texte1.position(20, -10);
  Texte1.html(TitrePage + " / côté tablette");

  // createCanvas(windowWidth, windowHeight);
  Canevas = createCanvas(500, 500);
  Canevas.position(Bord, Bord);

  CouleurVerte = color(50, 150, 50);

  //MenuLocal = createSelect();
  //MenuLocal.position(370, Bord + 167);
  //MenuLocal.option(NomSon1);
  //MenuLocal.option(NomSon2);
  //MenuLocal.style('font-size', '16px');
  //MenuLocal.size(180, 30);
  //MenuLocal.changed(MenuLocalEvent);

  //MenuDistant = createSelect();
  //MenuDistant.position(370, Bord + 167 + 40);
  //MenuDistant.option(NomSon1);
  //MenuDistant.option(NomSon2);
  //MenuDistant.style('font-size', '16px');
  //MenuDistant.size(180, 30); 
  //MenuDistant.changed(MenuDistantEvent);

  for (var i = 0; i < Bouton.length; i++) {
    Bouton[i] = createButton('Play');
    Bouton[i].style('background-color', CouleurVerte);
    Bouton[i].style('color', color(255, 255, 255));
    Bouton[i].style('font-size', '16px');
    Bouton[i].style('border', 'none');
    Bouton[i].style('border-radius', '6px');
    Bouton[i].position(Bord + DecalX + (i%2 * 80), Bord + DecalY + int(i/2)*40);
    Bouton[i].size(70, 30);
  }
  Bouton[0].html('Play1');
  Bouton[0].mouseClicked(ClicBoutonPlay1);
  Bouton[1].html('Pause1');
  Bouton[1].mouseClicked(ClicBoutonPause1);
  Bouton[2].html('Play2');
  Bouton[2].mouseClicked(ClicBoutonPlay2);
  Bouton[3].html('Pause2');
  Bouton[3].mouseClicked(ClicBoutonPause2);
  Bouton[4].html('Play3');
  Bouton[4].mouseClicked(ClicBoutonPlay3);
  Bouton[5].html('Pause3');
  Bouton[5].mouseClicked(ClicBoutonPause3);

  for (var i = 0; i < BoutonRec.length; i++) {
    BoutonRec[i] = createButton('');
    BoutonRec[i].style('background-color', CouleurVerte);
    BoutonRec[i].style('color', color(255, 255, 255));
    BoutonRec[i].style('font-size', '16px');
    BoutonRec[i].style('border', 'none');
    BoutonRec[i].style('border-radius', '6px');
    BoutonRec[i].position(Bord + DecalX + (i * 120), Bord + 225);
    BoutonRec[i].size(110, 30);
  }
  BoutonRec[0].html('Record');
  BoutonRec[0].style('background-color', color(255, 0, 0)); // Rouge
  BoutonRec[0].mouseClicked(ClicBoutonRecord);
  BoutonRec[1].html('Play');
  BoutonRec[1].mouseClicked(ClicBoutonPlay);
  BoutonRec[2].html('Save');
  BoutonRec[2].mouseClicked(ClicBoutonSave);

  SliderVertical = createSlider(0, 100, 50);
  SliderVertical.position(290, 290);
  SliderVertical.size(450);
  SliderVertical.style('transform', 'rotate(270deg)'); //

  for (i = 0; i < ChampTexte.length; i++) {
    ChampTexte[i] = createInput(AdressIP[i]);
    ChampTexte[i].size(50, 30);
    ChampTexte[i].position(Bord + 10 + 60 * i, 400);
    ChampTexte[i].style('font-size', '16px');
    ChampTexte[i].style('text-align', 'center');
    ChampTexte[i].changed(FormAdressIP);
  }

  Texte2 = createElement('h4', '');
  Texte2.position(20, 540);
  FormAdressIP();

  DureeSon = Son.duration();
  analyse = new p5.Amplitude(); // create a new Amplitude analyse
  analyse.setInput(Son);

  if (true) {
    //socket = io.connect(AdressIPServer); // Start a socket connection to the server
    //console.log("io.connect(" + AdressIPServer + ")");
    //// We make a named event called 'PlayFile1' and write an anonymous callback function
    //socket.on('PlayFile1', // When we receive data
    //  function(data) {
    //  Reception = data.x;
    //  console.log("Got: " + data.x);
    //  NbrPlayServer = NbrPlayServer + 1;
    //  if (Reception == 'Play') Son.play();
    //  else if (Reception == 'Pause') Son.pause();
    //  else if (Reception == 'Stop') Son.stop();
    //  else {
    //    NomSon = Reception;
    //    ChargeSon();
    //  }
    //}
    //);
  }
  print('Fin setup');
}

function draw() {
  background(230);
  fill(255);
  // rect(180, 252, 300, 14);
  fill(CouleurVerte);
  textAlign(LEFT);
  textSize(18);
  //text('File: ' + NomSon, 20, 20);
  //text("Duration: " + int(DureeSon * 10) / 10 + " seconds", 20, 40);
  //text("Channels: " + Son.channels(), 20, 60);
  //text("SampleRate: " + Son.sampleRate() + " samples / sec", 20, 80);

  //text("Time: " + int(Son.currentTime() * 10) / 10 + " seconds", 20, 120);
  //if (Son.isPlaying()) rms = int(analyse.getLevel() * 1000);
  //text("RMS level: " + rms / 10 + " ", 20, 140);
  //rect(150, 132, rms, 14);
  //text("Local:", 20, 180);
  text(Recu1, DecalX + 160, DecalY + 15);
  text(Recu2, DecalX + 160, DecalY + 55);
  text(Recu3, DecalX + 160, DecalY + 95);
  //text("Distant:", 20, 220);
  //text("Chargement: " + Progress, 20, 260);
  //rect(180, 252, Progress * 300, 14);
  // text(NbrPlayServer, 420, 320);
  fill(0);
  //text("Reception " + NbrPlayServer + ": " + Reception, 20, 320);
  textAlign(LEFT);
  // textSize(20);
  text("AdressIP Server:", 10, 337);

  var NouveauVolume = SliderVertical.value() / 100;
  if (Volume != NouveauVolume) { // Envoi Volume quand il change
    Volume = NouveauVolume;
    // masterVolume(Volume); // OK Firefox
    Envoyer('Volume', Volume);
  }
  text("Niveau " + Volume, 370, 470);

  AfficheFrame();
}

function MenuLocalEvent() {
  var item = MenuLocal.value();
  print(item);  
  NomSon =item;
  ChargeSon();
}

function ChargeSon() {
  if (Son.isPlaying()) Son.stop();
  loadSound(NomSon, ChargementOK, ChargementPB, ChargementProgress);
}

function ChargementOK(soundFile) {
  Son = soundFile;
  DureeSon = Son.duration();
  print('ChargementOK');  
  analyse.setInput(Son);
}

function ChargementPB(e) {
  console.log('ChargementPB');  
  console.log('New error:');
  console.log('- name: ' + e.name);
  console.log('- message: ' + e.message);
  console.log('- stack: ' + e.stack);
  console.log('- failed path: ' + e.failedPath);
}

function ChargementProgress(P) {
  Progress = P;
  // Progress = 0.123;
  print('Progress = ' + Progress);
}

//function ClicBoutonPlayLocal() {
//  Son.play();
//  return false; // https://p5js.org/reference/#/p5/mouseClicked
//}

//function ClicBoutonPauseLocal() {
//  Son.pause();
//  return false; // https://p5js.org/reference/#/p5/mouseClicked
//}

//function ClicBoutonStopLocal() {
//  Son.stop();
//  return false; // https://p5js.org/reference/#/p5/mouseClicked
//}

//function MenuDistantEvent() {
//  var item = MenuDistant.value();
//  print(item);  
//  NomSonDistant =item;
//  MenuDistantEnvoi();
//}

function ClicBoutonPlay1() { 
  Envoyer(1, 'Play');
}

function ClicBoutonPause1() { 
  Envoyer(1, 'Pause');
}

function ClicBoutonPlay2() { 
  Envoyer(2, 'Play');
}

function ClicBoutonPause2() { 
  Envoyer(2, 'Pause');
}

function ClicBoutonPlay3() { 
  Envoyer(3, 'Play');
}

function ClicBoutonPause3() { 
  Envoyer(3, 'Pause');
}

function ClicBoutonRecord() { 
  Envoyer(4, 'Record');
}

function ClicBoutonPlay() { 
  Envoyer(4, 'Play');
}

function ClicBoutonSave() { 
  Envoyer(4, 'Save');
}

//function MenuDistantEnvoi() {
//  Envoyer(NomSonDistant);
//}

function Envoyer(Message1, Message2) {
var data = {x: 
Message1, y: 
  Message2
};
socket.emit('Capsule', data); // 
console.log("Envoyer: Tablette  " + Message1 + "  " + Message2);
}

function AfficheFrame() {
  var y = height/2 + 200;
  var DecalX = -200;
  fill(255, 255, 255);
  ellipse(width/2 + DecalX, y, 100, 100);
  textAlign(CENTER, CENTER);
  textSize(25);
  fill(0, 0, 0);
  text("Frame:", width/2 + DecalX, y - 15);
  text(frameCount, width/2 + DecalX, y + 15);
}

function FormAdressIP() { // Exemple: http://192.168.1.20:4000
  var sss = "";
  for (i = 0; i < ChampTexte.length; i++) {
    AdressIP[i] = int(ChampTexte[i].value());
    if (AdressIP[i] < 0) AdressIP[i] = 0;
    if (AdressIP[i] > 9999) AdressIP[i] = 9999;
    if ((AdressIP[i] > 255) && (i < 4)) AdressIP[i] = 255;
    if (AdressIP[i] !== AdressIP[i]) AdressIP[i] = 0; // NaN Astuce
    ChampTexte[i].value(AdressIP[i]);
  }
  AdressIPServer = "http://" + AdressIP[0] + "." + AdressIP[1] + "." + AdressIP[2] + "." + AdressIP[3] + ":" + AdressIP[4];
  Texte2.html("AdressIP Server = " + AdressIPServer);
  socket = io.connect(AdressIPServer); // Start a socket connection to the server
  console.log("io.connect(" + AdressIPServer + ")");

  socket.on('Tablette', // When we receive data
    function(data) {
    Reception1 = data.x;
    Reception2 = data.y;
    console.log("Got: " + data.x + "   " + data.y );
    NbrPlayServer = NbrPlayServer + 1;
    if (Reception1 == '1') Recu1 = Reception2;
    if (Reception1 == '2') Recu2 = Reception2;
    if (Reception1 == '3') Recu3 = Reception2;
    if (Reception1 == '4') BoutonRec[0].html(Reception2);
    ;
    if (Reception1 == '5') BoutonRec[1].html(Reception2);
    ;
    if (Reception1 == '6') BoutonRec[2].html(Reception2);
    ;
  }
  );
}
